{# heredando header y footer #}
{% extends "./plantilla.html" %}
{% load static %}
  {% block contenido %}

    <br>
    <div class="container-fluid py-4">
      <div class="row">
        <div class="col-xl-2 col-sm-6 mb-xl-0 mb-9">
        </div>
        <div class="col-xl-10 col-sm-6 mb-xl-0 mb-9">
          <h3>REGISTRO DE CARRERAS</h3>
          <form class="" action="/guardarCarrera/" method="post" enctype="multipart/form-data" id='frm_nuevo_carrera'>
            {% csrf_token %}
            <div class="row">
              <div class="col-md-6">
                <b>NOMBRE:</b>
                <input type="text" name="nombreCarreraGEPT" id="nombreCarreraGEPT" value="" placeholder="Ingrese el nombre de la Carrera" class="form-control" required>
                <br>
                <b>DIRECTOR:</b>
                <input type="text" name="directorCarreraGEPT" id="directorCarreraGEPT" value="" placeholder="Ingrese el nombre del Director" class="form-control" required>
                <br>
                <b>FACULTAD:</b>
                <input type="text" name="facultadCarreraGEPT" id="facultadCarreraGEPT" value="" placeholder="Ingrese la Facultad de la Carrera" class="form-control" required>
                <br>
                <b>MODALIDAD:</b>
                <input type="text" name="modalidadCarreraGEPT" id="modalidadCarreraGEPT" value="" placeholder="Ingrese la Modalidad de la Carrera" class="form-control" required>
                <br>
              </div>
              <div class="col-md-6">
                <b>LOGO:</b>
                <input type="file" accept="image/*" name="logoCarreraGEPT" id="logoCarreraGEPT" value="" placeholder="Ingrese el logo de la carrera" class="form-control" required>
                <br>

              </div>
            </div>
            <center>
              <button type="submit" name="button" class="btn btn-info bg-gradient-info">Guardar</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
              <a type="reset" name="button" class="btn btn-danger bg-gradient-danger" href="/">Cancelar</a>
            </center>
          </form>
          <hr>
        <div class="col-md-12">
          <table class="table table-striped" id="tbl_carrera" style="color: black;">
            <h3>LISTADO DE CARRERAS</h3>
            <div class="d-flex justify-content-center" >
              <img src="{% static 'img/4.jpg' %}" alt="" class="img-fluid">
            </div>
            <thead>
              <tr>
                <th>ID</th>
                <th>NOMBRE</th>
                <th>DIRECTOR</th>
                <th>LOGO</th>
                <th>FACULTAD</th>
                <th>MODALIDAD</th>
                <th>ACCIONES</th>
              </tr>
            </thead>
            <tbody>
              {% for carrera in carreras %}
                <tr>
                  <td>{{carrera.idCarreraGEPT}}</td>
                  <td>{{carrera.nombreCarreraGEPT}}</td>
                  <td>{{carrera.directorCarreraGEPT}}</td>
                  <td>
                    {% if carrera.logoCarreraGEPT %}
                      <a href="{{carrera.logoCarreraGEPT.url}}" target="_blank"><img src="{{carrera.logoCarreraGEPT.url}}" alt="" height="50px"></a>
                    {% else %}
                      <b>N/A</b>
                    {% endif %}
                  </td>
                  <td>{{carrera.facultadCarreraGEPT}}</td>
                  <td>{{carrera.modalidadCarreraGEPT}}</td>
                  <td>
                    <a href="/editarCarrera/{{carrera.idCarreraGEPT}}" class="btn btn-warning bg-gradient-warning">Editar</a>
                    <a href="javascript:void(0)" class="btn btn-danger bg-gradient-danger" onclick="eliminarCarrera('/eliminarCarrera/{{carrera.idCarreraGEPT}}');">Eliminar</a>
                  </td>
                </tr>
                {% endfor %}
            </tbody>
          </table>
          <button id="toggleChartButton" onclick="toggleChart()" class="btn btn-info bg-gradient-info">Mostrar/ocultar gráfico</button>
        </div>
      </div>
    </div>
  </div>
    <script type="text/javascript">
      function eliminarCarrera(url){
        iziToast.question({
            timeout: 15000,
            close: true,
            overlay: true,
            displayMode: 'once',
            id: 'question',
            zindex: 999,
            title: 'CONFIRMACIÓN',
            message: '¿Está seguro de eliminar la Carrera seleccionada?',
            position: 'center',
            buttons: [
                ['<button><b>SI</b></button>', function (instance, toast) {
                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                    window.location.href=url;
                }, true],
                ['<button>NO</button>', function (instance, toast) {

                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');

                }],
            ]
        });
      }
    </script>
    <script type="text/javascript">
      $(document).ready(function() {
        $("#frm_nuevo_carrera").validate({
          rules: {
            "nombreCarreraGEPT": {
              required: true,
              lettersOnly: true // Validar solo letras
            },
            "directorCarreraGEPT": {
              required: true,
              lettersOnly: true // Validar solo letras
            },
            "logoCarreraGEPT": {
              required: true
            },
            "facultadCarreraGEPT": {
              required: true,
              lettersOnly: true // Validar solo letras
            },
            "modalidadCarreraGEPT": {
              required: true,
              lettersOnly: true // Validar solo letras
            }
          },
          messages: {
            "nombreCarreraGEPT": {
              required: "Debe ingresar el nombre de la Carrera"
            },
            "directorCarreraGEPT": {
              required: "Debe ingresar el nombre del Director"
            },
            "logoCarreraGEPT": {
              required: "Debe ingresar el logo"
            },
            "facultadCarreraGEPT": {
              required: "Debe ingresar la facultad de la carrera"
            },
            "modalidadCarreraGEPT": {
              required: "Debe ingresar la modalidad de la carrera"
            }
          }
        });

        $.validator.addMethod("lettersOnly", function(value, element) {
          return this.optional(element) || /^[a-zA-Z\s]+$/.test(value);
        }, "Ingrese solo letras");

        $.validator.addMethod("digits", function(value, element) {
          return this.optional(element) || /^[0-9]+$/.test(value);
        }, "Ingrese solo números");
      });
    </script>

    <script type="text/javascript">
       //let table = new DataTable('#tbl_clientes');
       $(document).ready(function() {
           $('#tbl_carrera').DataTable({
               dom: 'Bfrtip',
               language: {
                 url: '//cdn.datatables.net/plug-ins/1.13.7/i18n/es-ES.json',
               },
               buttons: [
                   {
                       extend: 'pdfHtml5',
                       text: '<i class="fa fa-file-pdf-o"></i> PDF',
                       titleAttr: 'Exportar a PDF',
                       className: 'btn btn-danger bg-gradient-danger', // Clase de estilo para el botón
                       title: 'LISTADO DE LAS CARRERAS'
                   },
                   {
                       extend: 'print',
                       text: '<i class="fa fa-print"></i> Imprimir',
                       titleAttr: 'Imprimir',
                       className: 'btn btn-primary bg-gradient-primary', // Clase de estilo para el botón
                       title: 'LISTADO DE LAS CARRERAS'
                   },
                   {
                       extend: 'csv',
                       text: '<i class="fa fa-file-text-o"></i> CSV',
                       titleAttr: 'Exportar a CSV',
                       className: 'btn btn-success bg-gradient-sucess' // Clase de estilo para el botón
                   }
               ]
           });
       });
      </script>
      <script>
        $(document).ready(function () {
            $("#logoCarreraGEPT").fileinput({
              //showUpload:false
              //showRemove: false,
              language:'es',
            });
        });
      </script>


      <div id="chartContainer" style="width: 50%; margin: auto; border: 2px solid black; padding: 10px; display: none;">
        <canvas id="myChart"></canvas>
      </div>

      <script>
          document.addEventListener('DOMContentLoaded', function () {
            const ctx = document.getElementById('myChart');

            const carreraSet = new Set();

            const carreraMod = {};
            {% for carrera in carreras %}
              carreraSet.add("{{ carrera.modalidadCarreraGEPT }}");
              if (!carreraMod["{{ carrera.modalidadCarreraGEPT }}"]) {
                carreraMod["{{ carrera.modalidadCarreraGEPT }}"] = 1;
              } else {
                carreraMod["{{ carrera.modalidadCarreraGEPT }}"] += 1;
              }
            {% endfor %}
            const carreraArray = Array.from(carreraSet);
            const posiciones = carreraArray.map((carrera, index) => ({ x: index, y: carreraMod[carrera] || 0 }));

            new Chart(ctx, {
              type: 'bar',
              data: {
                labels: carreraArray,
                datasets: [{
                  label: 'Modalidad',
                  data: posiciones.map(posicion => posicion.y),
                  backgroundColor: 'rgba(248, 192, 192)',
                  borderColor: 'rgba(248, 192, 192)',
                  borderWidth: 1,
                }]
              },
              options: {
                scales: {
                  x: {
                    type: 'category',
                    position: 'bottom',
                  },
                  y: {
                    beginAtZero: true,
                    max: 10,
                    stepSize: 1,
                  }
                }
              }
            });
            window.toggleChart = function() {
              const chartContainer = document.getElementById('chartContainer');

              if (chartContainer.style.display === 'none') {
                chartContainer.style.display = 'block';
              } else {
                chartContainer.style.display = 'none';
              }
            };
          });

      </script>
  {% endblock %}
